unit UGoal2DTeamAway;

// Players with this goal will be scared by some team member and scape from them.

interface

uses UGoal, UPlayer2D, UTeam;

type TGoal2DTeamAway = class(TGoal)
  private
    BullyTeam: TTeam;
  protected
  public
    constructor create(C: double; T: TTeam);
    procedure CalcScore(FireAt: TGoalFire); override;
  end;


implementation

uses Math;


constructor TGoal2dTeamAway.create(C: double; T: TTeam);
begin
  inherited create(c);
  Strength:= C;
  fDrawable:= false;
  BullyTeam:= T;
  fDisplayName:= 'Avoid others';
end;

procedure TGoal2dTeamAway.CalcScore(FireAt: TGoalFire);
var
  i: integer;
  d: double;
  p, p2: TPlayer2D;
begin
  inherited;
  p:= TPLayer2D(Player);
  if p.Dead then exit;
  if (FireAt = gfStep) then begin
    // All players on the "bully team" do repel me:
    for i:= 0 to BullyTeam.PlayerCount-1 do begin
      p2:= TPlayer2D(BullyTeam.Player[i]);
      if (p<>p2) then begin
        d:= Sqrt(Sqr(p.PosX-p2.PosX)+Sqr(p.PosY-p2.PosY)) / (10*Strength*p.Size);
        //Reduce:= Min(1, Sqrt(d/Strength)); // Only fires at close distances

        //Reduce:= d/(1+d); // Fires always.
        Reduce:= Min(d, 1);

        //TPlayer2D(Player).State.ScoreRed:= TPlayer2D(Player).State.ScoreRed * Min(1, Sqrt(d/Coef));

        // Test 1:
        //d:= Sqrt(Sqr(p.PosX-p2.PosX)+Sqr(p.PosY-p2.PosY));
        //TPlayer2D(Player).State.ScoreMultiplier:= TPlayer2D(Player).State.ScoreMultiplier * (d/(d+Coef));
        //
        // Test 2:
        //d:= Sqrt(Sqr(p.PosX-p2.PosX)+Sqr(p.PosY-p2.PosY));
        //d_old:= Sqrt(Sqr(p.OldPosX-p2.OldPosX)+Sqr(p.OldPosY-p2.OldPosY));
        // If you run away and get the distance grwo a 1%, you have a +1 score.
        //if (d_old > 0.0001) then
        //  Score:= Max(0, d-d_old)/d_old*100
      end
    end;
  end;
end;

end.
