unit UGoalBurnOut;

interface

uses UGoal, UPlayer2D, UTeam;

type TGoalBurnOut = class(TGoal)
  private
    TheTeam: TTeam;
  protected
    procedure CalcScore(FireAt: TGoalFire); override;
  public
    constructor create(c: double; T: TTeam);
  end;


implementation

uses Forms, UTrack, UTrack2D, Graphics, URocket;


constructor TGoalBurnOut.create(C: double; T: TTeam);
begin
  inherited create(c);
  Strength:= C;
  TheTeam:= T;
  fDrawable:= false;
  fDisplayName:= 'Stole energy from others';
end;

procedure TGoalBurnOut.CalcScore(FireAt: TGoalFire);
var
  i: integer;
  EndX, EndY: double;
  OldEnergy, Sucked: double;
  p, p2: TPlayer2D;
  r: TRocket;
begin
  inherited;
  p:= TPLayer2D(player);
  if not (p is TRocket) then exit;
  r:= TRocket(p);
  if r.Dead or (r.Energy>99) then exit;
  if (FireAt = gfStep) then begin
    // I can take energy from all players if I touch them with my fire:
    EndX:= round(r.PosX - cos(r.Angle) * (r.Size + r.MainPower));
    EndY:= round(r.PosY - sin(r.Angle) * (r.Size + r.MainPower));
    for i:= 0 to TheTeam.PlayerCount-1 do begin
      p2:= TPlayer2D(TheTeam.Player[i]);
      if (p<>p2) then begin
        // Vector from me to the other player:
        if Sqrt(Sqr(p2.PosX-EndX) + Sqr(p2.PosY-EndY)) < p2.Size then begin
          // OK, the victim is at reach... take its energy!
          OldEnergy:= p2.Energy;
          // Adjust it so 1 second is need to suck 100% of other's energy:
          p2.Energy:= p2.Energy - 100*p.SimSeconds;
          Sucked:= OldEnergy - p2.Energy;
          p.Energy:= p.Energy + Sucked/2;

          // Debugging:
          if (not p.Imagining) and (TTrack(p.Track) is TTrack2D) then begin
            TTrack2D(p.Track).Img.Canvas.Pen.Color:= clRed;
            TTrack2D(p.Track).Img.Canvas.Pen.Width:= 3;
            TTrack2D(p.Track).Img.Canvas.MoveTo(round(TPlayer2D(p ).PosX), round(TPlayer2D(p ).PosY));
            TTrack2D(p.Track).Img.Canvas.LineTo(round(TPlayer2D(p2).PosX), round(TPlayer2D(p2).PosY));
            TTrack2D(p.Track).Img.Canvas.Pen.Width:= 1;
            Application.ProcessMessages;
          end;

        end;
      end
    end;
  end;
end;


end.
