unit UGoalEnergy;

interface

uses UGoal, UPlayer;

type TGoalEnergy = class(TGoal)
  private
  protected
  public
    CombineWithPositive: boolean;
    constructor create(c: double); override;
    procedure CalcScore(FireAt: TGoalFire); override;
  end;


implementation

uses Math;


constructor TGoalEnergy.create;
begin
  inherited;
  fDisplayName:= 'Cares about energy';
  CombineWithPositive:= true;
end;

procedure TGoalEnergy.CalcScore(FireAt: TGoalFire);
var p: TPlayer;
begin
  inherited;
  if (FireAt = gfEnd) then begin
    p:= TPlayer(Player);
    // As a negative goal (a disaster):
    // Score:= (p.Energy - p.OldEnergy) / Max(0.01, p.OldEnergy);;
    //
    // As a positive goal mixed with reduction: it works better this way.
    if CombineWithPositive then
      Score:= p.Energy;
    // As a reductive goal:
    Reduce:= Power(p.Energy/100, 2);
  end;
end;

end.
