unit UGoalHealth;

interface

uses UGoal, UPlayer;

type TGoalHealth = class(TGoal)
  private
  protected
  public
    CombineWithPositive: boolean;
    constructor create(c: double); override;
    procedure CalcScore(FireAt: TGoalFire); override;
  end;


implementation

uses Math, Graphics, UPlayer2D, UTrack2D;

constructor TGoalHealth.create;
begin
  inherited;
  fDisplayName:= 'Cares about health';
  CombineWithPositive:= true;
end;

procedure TGoalHealth.CalcScore(FireAt: TGoalFire);
var
  p: TPlayer;
  t, maxt: Int64;
begin
  inherited;
  if (FireAt = gfEnd) then begin
    p:= TPlayer(Player);
    // As a positive goal. Mixed with reduction works better.
    if CombineWithPositive then
      Score:= p.Health;
    // As a reductive goal (quite nice):
    Reduce:= Power(p.Health/100, 2);
  end;
end;


end.
 