unit UGoalMouse;

interface

uses UGoal, UPlayer2D, UTeam;

type TGoalMouse = class(TGoal)
  private
    fRepel: boolean;
  protected
  public
    constructor create(C: double; Repel: boolean = false);
    procedure NeutralDraw; override;
    procedure CalcScore(FireAt: TGoalFire); override;
  end;

implementation

uses UTrack2D, Graphics, ExtCtrls, Math;


constructor TGoalMouse.create(C: double; Repel: boolean = false);
begin
  inherited create(c);
  Strength:= C;
  fRepel:= Repel;
  if Repel then
    fDisplayName:= 'Avoid mouse'
  else
    fDisplayName:= 'Follow mouse';
end;

procedure TGoalMouse.CalcScore(FireAt: TGoalFire);
var
  x, y: integer;
  d: double;
  p: TPlayer2D;
  t: TTrack2D;
begin
  inherited;
  p:= TPLayer2D(Player);
  if p.Dead then exit;
  if (FireAt = gfStep) then begin
    t:= TTrack2D(p.Track);
    if t.MouseIn then begin
      x:= t.MouseX;
      y:= t.MouseY;
      d:= Sqrt(Sqr(p.PosX-x)+Sqr(p.PosY-y)) / (1+p.Size);
      if fRepel then begin
        Reduce:= Min( Sqrt(d/100) , 1);
      end else begin
        Reduce:= Sqrt( 1/(d/100+1) );
      end;
    end;
  end;
end;

procedure TGoalMouse.NeutralDraw;
var
  p: TPlayer2D;
  t: TTrack2D;
  C: TCanvas;
const
  Size: integer = 10;
begin
  if not Assigned(Player) then exit;
  p:= TPlayer2D(player);
  t:= TTrack2D(p.Track);
  C:= t.Img.Canvas;
  // A square half filled will do as a storage:
  C.Pen.Color:= clBlue;
  C.Brush.Style:= bsClear;
  C.Ellipse(round(t.MouseX-Size), round(t.MouseY-Size), round(t.MouseX+Size), round(t.MouseY+Size));
  C.MoveTo(round(t.MouseX), round(t.MouseY-Size));
  C.LineTo(round(t.MouseX), round(t.MouseY+Size));
  C.MoveTo(round(t.MouseX-Size), round(t.MouseY));
  C.LineTo(round(t.MouseX+Size), round(t.MouseY));
end;

end.
